#!/usr/bin/env ruby

$: << '/path/to/metasm'	# put the path to metasm here (or in the RUBYLIB environment variable)

# load the metasm ruby library
require 'metasm'
# include all the Metasm classes in the current namespace
include Metasm

$VERBOSE = true		# show what's going on in the console

# load the grimcreeper.d binary in the disassembler
file = 'grimcreeper.d'
# create the PE/ELF object from the file
exe = AutoExe.decode_file(file)
# initialize a Disassembler from the executable
dasm = exe.disassembler

# load the gui, tell it to disassemble from 'entrypoint'
Gui::DasmWindow.new("metasm disassembler - #{file}", dasm, 'entrypoint')
dasm.load_plugin 'hl_opcode'	# load the 'highlight opcodes' GUI plugin
Gui.main	# main loop
