#!/usr/bin/env ruby

require 'metasm'
include Metasm

# patch the control flow by hooking the resolution of the jmp eax target

# load the binary
file = 'grimcreeper.d'
ep = 'parse_options'

e = AutoExe.decode_file(file)
dasm = e.disassembler

# setup a disassembler callback
dasm.callback_newaddr = lambda { |orig, target|
	# this lambda called for every new adress found by the disassembler
	if dasm.di_at(orig).instruction.to_s != 'jmp eax'
		next target
	end

	# check that we are at the right instruction

	mov = dasm.di_including(orig-1)
	switch_addr = mov.instruction.args[1].imm.reduce

	# retrieve the content of the switch table
	switch_entries = []
	6.times { |nr|
		# retrieve each entry, push it into the switch_entries array
		switch_entries << dasm.decode_int(switch_addr + 4*nr, 4)
	}

	# return the values
	switch_entries
}

# now that the hook is in place, we can start to disassemble
dasm.disassemble(ep)

# run the gui to check the results
Gui::DasmWindow.new("metasm disassembler - #{file}", dasm, ep)
Gui.main



