#!/usr/bin/env ruby

require 'metasm'  # load metasm
include Metasm    # avoid Metasm::Bla

file = 'grimcreeper.d'
ep = 'parse_options'

e = AutoExe.decode_file(file)
d = e.disassembler

d.callback_newaddr = lambda { |orig, target|
	# check if we are at the jmp
	next target if not di = d.di_at(orig)
	next target if di.instruction.opname != 'jmp'
	a = di.instruction.args.first
	next target if not a.kind_of?(Ia32::Reg) or a.symbolic != :eax

	puts "found the switch #{di}"

	# get mov eax, [804a110h+4*edx] instruction from block's instructions list.
	mov = di.block.list[-2]
	modrm = mov.instruction.args.last
	base = modrm.imm

	# return all switch entries
	(0..5).map { |idx| Indirection[base+4*idx, 4, orig] }
}

d.disassemble(ep)

Gui::DasmWindow.new("metasm disassembler - #{file}", d, ep)
d.load_plugin 'hl_opcode'
Gui.main
